# Helper functions, names for plotting, etc.

scaleRan = list(
  pitch = c(0, 12 * log2(4300 / 62)),  # the range in semitones
  height = c(128, 202),
  aggression = c(0, 100),
  formidability = c(0, 100),
  roughness = c(0, 100),
  timbre = c(0, 100)
)
# a helper function for converting 01 to the original rating scale (eg cm for height)
deNorm = function(data, myvar = c('fit', 'lwr', 'upr'), centered = FALSE, refScale = NULL) {
  for (i in 1:nrow(data)) {
    if (is.null(refScale)) {
      ref = scaleRan[[as.character(data$scale[i])]]
    } else {
      ref = scaleRan[[refScale]]
    }
    if (centered) {
      data[i, myvar] = data[i, myvar] * (ref[2] - ref[1])
    } else {
      data[i, myvar] = data[i, myvar] * (ref[2] - ref[1]) + ref[1]
    }
  }
  return(data)
}

# Pretty names for plotting
names_nlps = list(
  'none' = 'No NLPs',
  'subh' = 'Subharmonics',
  'am' = 'Amplitude\nmodulation',
  'chaos' = 'Chaos'
)

names_scales = list(
  'pitch' = 'Pitch, semitones',
  'timbre' = 'Timbre, %',
  'roughness' = 'Roughness, %',
  'height' = 'Height, cm',
  'formidability' = 'Formidability, %',
  'aggression' = 'Aggression, %'
)

names_scales_firstup = list(
  'pitch' = 'Pitch',
  'timbre' = 'Timbre',
  'roughness' = 'Roughness',
  'height' = 'Height',
  'formidability' = 'Formidability',
  'aggression' = 'Aggression'
)

names_ac = list(
  'pitch' = 'Pitch',
  'specCentroid' = 'Spectral centroid',
  'roughness' = 'Roughness',
  'HNR' = 'HNR'
)

